/*
 * 
 * $Copyright
 * Copyright 1993, 1994 , 1995 Intel Corporation
 * INTEL CONFIDENTIAL
 * The technical data and computer software contained herein are subject
 * to the copyright notices; trademarks; and use and disclosure
 * restrictions identified in the file located in /etc/copyright on
 * this system.
 * Copyright$
 * 
 */
 
/*
 * Copyright (c) 1991-1995, Locus Computing Corporation
 * All rights reserved
 */
/*
 * $Log: pvpops.c,v $
 * Revision 1.9  1995/02/01  21:45:42  bolsen
 *  Reviewer(s): Jerry Toman
 *  Risk: Medium (lots of files)
 *  Module(s): Too many to list
 *  Configurations built: STD, LITE, & RAMDISK
 *
 *  Added or Updated the Locus Copyright message.
 *
 * Revision 1.8  1994/11/18  20:43:34  mtm
 * Copyright additions/changes
 *
 * Revision 1.7  1994/06/18  00:42:01  jlitvin
 * Remove embedded comment characters to make lint happier.
 *
 * Revision 1.6  1993/07/14  18:33:05  cfj
 * OSF/1 AD 1.0.4 code drop from Locus.
 *
 * Revision 1.1.1.4  1993/07/01  20:45:28  cfj
 * Adding new code from vendor
 *
 * Revision 1.5  1993/06/09  00:09:41  cfj
 * Change occurances of #include <i860ipsc/mcmsg> to #include <i860paragon/mcmsg>
 *
 * Revision 1.4  1993/05/06  19:22:37  cfj
 * ad103+tnc merged with Intel code.
 *
 * Revision 1.1.1.2  1993/05/03  17:45:35  cfj
 * Initial 1.0.3 code drop
 *
 * Revision 1.3  1992/11/30  22:47:30  dleslie
 * Copy of NX branch back into main trunk
 *
 * Revision 1.1.2.2  1992/11/06  20:31:20  dleslie
 * Merged bug drop from Locus November 3, 1992, with NX development
 *
 * Revision 1.1.2.1  1992/11/05  22:45:43  dleslie
 * Local changes for NX through noon, November 5, 1992.
 *
 * Revision 3.8  1992/10/28  15:27:28  roman
 * Include procedure prototypes generated by makeTNCtables.sh for
 * 	better type-checking.
 *
 * Revision 3.7  92/10/08  17:04:26  chrisp
 * Contents gutted and replaced with #include of generated stubs.
 * 
 * Revision 3.6  92/09/29  08:02:48  roman
 * Minor formatting fixes.
 * Change migrate lock invocations to movement lock invocations (name change).
 * Add new pvproc ops for adding and removing foster children.
 * Change name of set_state pvproc op to report_state.
 * Get rid of setpinit and killall pvproc ops.
 * Add terminal_sigpgrp pvproc op.
 * Parameter changes to ctty_getattr pvproc op.
 * 
 * Revision 3.5  92/07/08  09:08:30  roman
 * Correct prior RCS comment.
 * 
 * Revision 3.4  92/06/26  13:54:03  chrisp
 * [Bug #35] Zombie or stopped children assigned to a new parent must have
 * 	their correct state recorded in their vproc on the parent's node.
 * 
 * Revision 3.3  92/06/17  09:13:37  roman
 * [Bug 0026] New vproc op VPOP_GET_TASK_PORT() added to get task_by_pid() 
 *	system call working.
 * 
 * Revision 3.2  92/05/07  10:47:01  chrisp
 * [Bug #10] Add optional second signal number to PVPOP_SIGPROC().
 * 
 * Revision 3.1  92/04/30  10:49:43  chrisp
 * [Bug #3] PVPOP_REAP() now takes an additional parameter requiring a reaped
 * 	process belong to a specified pgid (if not WAIT_ANY); error ESRCH
 * 	is returned if this is not the case and the process is not reaped.
 * 	This avoids VPOP_WAIT() using PVPOP_GETATTR() for each child's pgid.
 * 
 * Revision 3.0  92/03/18  11:53:55  roman
 * Initial submission of this file.
 * 
 */

#include <sys/types.h>
#include <sys/errno.h>
#include <uxkern/import_mach.h>
#include <sys/vproc.h>
#define	PVPOP_VIA_TABLE
#include <tnc/dpvproc.h>
#include <uxkern/proc_to_task.h>

#ifdef NX
#include <i860paragon/mcmsg/mcmsg_info.h>
#endif /* NX */

#define PVP_OP(vp,op,str)			\
	int error;				\
	VPROC_HOLD_MOVEMENT(vp,str);		\
	while ((error = op) == EREMOTE)		\
		;				\
	VPROC_RELEASE_MOVEMENT(vp,str);		\
	return(error);

/*
 * Include wrapper routines generated from the TNC header files.
 * Each operations wrapper is of the form:
 *	int <op_name>(
 *		struct vproc *<parm_name_1>,
 *		<parm_type_2> <parm_name_2>,
 *			... repeated 
 *		<parm_type_n> <parm_name_n>)
 *	{
 *		PVP_OP(<parm_name_1>,
 *			<OP_NAME>(<parm_name_1>,...<parm_name_n>),"<op_name>");
 *	}
 */
#include <tnc/pvpops_gen.c>
